// SystemApplicationDlg.h : header file
//

#if !defined(AFX_SYSTEMAPPLICATIONDLG_H__D955455A_CE91_11D2_8C81_000000000000__INCLUDED_)
#define AFX_SYSTEMAPPLICATIONDLG_H__D955455A_CE91_11D2_8C81_000000000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include "SystemInfo.h"
#include "DialogStatusBar.h"
#include "OSInfoPage.h"
#include "MiscInfoPage.h"
#include "MouseInfoPage.h"
#include "MemoryInfoPage.h"
#include "CPUInfoPage.h"
#include "HDiskInfoPage.h"
#include "StorageInfoPage.h"
#include "MultiMediaInfoPage.h"

class CSystemApplicationDlgAutoProxy;

/////////////////////////////////////////////////////////////////////////////
// CSystemApplicationDlg dialog

class CSystemApplicationDlg : public CDialog
{
	DECLARE_DYNAMIC(CSystemApplicationDlg);
	friend class CSystemApplicationDlgAutoProxy;

// Construction
public:
	CSystemApplicationDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CSystemApplicationDlg();

// Dialog Data
	//{{AFX_DATA(CSystemApplicationDlg)
	enum { IDD = IDD_SYSTEMAPPLICATION_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSystemApplicationDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

	static VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg, UINT uIDEvent,
		DWORD dwTime);

// Implementation
protected:
	CSystemApplicationDlgAutoProxy *m_pAutoProxy;
	HICON				m_hIcon;
	UINT				m_nIDTimer;
	CDialogStatusBar	m_wndStatusBar;
	CFont				m_StatusBarFont;
	CFile				m_fOutputFile;
	ISystemInformation	*m_pSystemInfo;

	CPropertySheet		m_PropSheet;
	OSInfoPage			m_OSInfoPage;
	MiscInfoPage		m_MiscInfoPage;
	MouseInfoPage		m_MouseInfoPage;
	MemoryInfoPage		m_MemoryInfoPage;
	CPUInfoPage			m_CPUInfoPage;
	HDiskInfoPage		m_HDiskInfoPage;
	StorageInfoPage		m_StorageInfoPage;
	MultiMediaInfoPage	m_MMediaInfoPage;

	BOOL CanExit();

	// Generated message map functions
	//{{AFX_MSG(CSystemApplicationDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnUpdateTimeIndicator(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	bool m_bIsOutputFileOpen;
	void CreateInterfacePointer ();
	bool CreateStatusBarFont ();
	bool OpenOutputFile ();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYSTEMAPPLICATIONDLG_H__D955455A_CE91_11D2_8C81_000000000000__INCLUDED_)
